import { jsx as l } from "react/jsx-runtime";
import { useMergeRefs as m, FloatingPortal as g, FloatingOverlay as p, FloatingFocusManager as M } from "@floating-ui/react";
import b from "clsx";
import * as a from "react";
import { useId as f } from "react";
import { ModalContext as C } from "./ModalContext.js";
import { useModalContext as d, useModal as v } from "./ModalHooks.js";
function I({
  children: s,
  ...t
}) {
  const n = v(t);
  return /* @__PURE__ */ l(C.Provider, { value: n, children: s });
}
const w = a.forwardRef(function(t, n) {
  const { context: r, ...o } = d(), e = m([o.refs.setFloating, n]);
  if (!r.open)
    return null;
  const { overlayBackground: c, ...i } = t, u = b("grid place-items-center", {
    [`${c}`]: c,
    "bg-black sm:bg-black/[.8]": !c
  });
  return /* @__PURE__ */ l(g, { children: /* @__PURE__ */ l(p, { className: u, lockScroll: !0, children: /* @__PURE__ */ l(M, { context: r, children: /* @__PURE__ */ l(
    "div",
    {
      ref: e,
      "aria-labelledby": o.labelId,
      "aria-describedby": o.descriptionId,
      ...o.getFloatingProps(i),
      children: i.children
    }
  ) }) }) });
}), D = a.forwardRef(function({ children: t, ...n }, r) {
  const { setLabelId: o } = d(), e = f();
  return a.useLayoutEffect(() => (o(e), () => o(void 0)), [e, o]), /* @__PURE__ */ l("h1", { ...n, ref: r, id: e, children: t });
}), E = a.forwardRef(function({ children: t, ...n }, r) {
  const { setDescriptionId: o } = d(), e = f();
  return a.useLayoutEffect(() => (o(e), () => o(void 0)), [e, o]), /* @__PURE__ */ l("div", { ...n, ref: r, id: e, children: t });
}), L = a.forwardRef(function(t, n) {
  const { setOpen: r } = d(), { trigger: o, className: e, ...c } = t, i = a.useCallback(() => r(!1), [r]);
  return /* @__PURE__ */ l("div", { className: e, children: a.cloneElement(o, {
    ref: n,
    onClick: i,
    ...c
  }) });
});
export {
  I as Modal,
  L as ModalClose,
  w as ModalContent,
  E as ModalDescription,
  D as ModalHeading
};
